<?php

use QUI\UserDownloads\Handler;
use QUI\UserDownloads\Exception as UserDownloadException;

QUI::$Ajax->registerFunction(
    'package_quiqqer_user-downloads_ajax_backend_delete',
    /**
     * Delete a user download entry
     *
     * @param int|string $ids
     * @throws UserDownloadException
     */
    function (int|string $ids) {
        try {
            $ids = json_decode($ids, true);

            foreach ($ids as $id) {
                $DownloadEntry = Handler::getDownloadEntryById((int)$id);
                $DownloadEntry->delete();
            }
        } catch (UserDownloadException $Exception) {
            QUI\System\Log::writeDebugException($Exception);
            throw $Exception;
        } catch (Exception $Exception) {
            QUI\System\Log::writeException($Exception);

            throw new UserDownloadException([
                'quiqqer/user-donwloads',
                'exception.ajax.backend.general'
            ]);
        }

        QUI::getMessagesHandler()->addSuccess(
            QUI::getLocale()->get(
                'quiqqer/user-downloads',
                'message.ajax.backend.delete.success'
            )
        );
    },
    ['ids'],
    'Permission::checkAdminUser'
);
