<?php

const QUIQQER_SYSTEM = true;
const QUIQQER_AJAX   = true;

require_once dirname(__FILE__, 4) . '/header.php';

use QUI\UserDownloads\Handler;
use QUI\Projects\Media\Utils as QUIMediaUtils;
use QUI\Utils\System\File as QUIFileUtils;

/**
 * @param int $code
 */
$exit = function (int $code = 403) {
    $Response = QUI::getGlobalResponse();
    $Response->setStatusCode($code);

    $Response->send();

    exit;
};

if (empty($_GET['hash'])) {
    $exit();
}

$hash = \QUI\Utils\Security\Orthos::clear($_GET['hash']);
$User = QUI::getUserBySession();

if (!QUI::getUsers()->isAuth($User)) {
    $exit();
}

$downloadEntries  = Handler::getDownloadEntriesByUser($User);
$downloadMediaUrl = false;

foreach ($downloadEntries as $DownloadEntry) {
    foreach ($DownloadEntry->getQuiqqerMediaUrls() as $quiqqerMediaUrl) {
        $mediaUrlhash = \hash('sha256', $quiqqerMediaUrl);

        if ($mediaUrlhash === $hash) {
            $downloadMediaUrl = $quiqqerMediaUrl;
            break;
        }
    }
}

if (!$downloadMediaUrl) {
    $exit(404);
}

try {
    $MediaItem = QUIMediaUtils::getMediaItemByUrl($downloadMediaUrl);

    if ($MediaItem->isDeleted()) {
        $exit(404);
    }

    QUIFileUtils::send($MediaItem->getFullPath());
} catch (\Exception $Exception) {
    QUI\System\Log::writeException($Exception);
    $exit(404);
}
